FactoryGirl.define do
  factory :icms_when_ICMS00, class: Nfe::Models::Taxes::ICMS do
    orig 2
    cst "00"
    modBC 3
    vBC 12345.67
    pICMS 234.56
    vICMS 23456.78
 end

  factory :icms_when_ICMS10, class: Nfe::Models::Taxes::ICMS do
    orig 2
    cst "10"
    modBC 3
    vBC 12345.67
    pICMS 234.56
    vICMS 23456.78
    modBCST 5
    pMVAST 345.67
    pRedBCST 456.78
    vBCST 91234.56
    pICMSST 678.91
    vICMSST 12345.67
  end

  factory :icms_when_ICMS20, class: Nfe::Models::Taxes::ICMS do
    orig 0
    cst "20"
    modBC 2
    pRedBC 123.45
    vBC 123456789.01
    pICMS 234.56
    vICMS 23456.78
  end

  factory :icms_when_ICMS30, class: Nfe::Models::Taxes::ICMS do
    orig 2
    cst "30"
    modBCST 5
    pMVAST 345.67
    pRedBCST 456.78
    vBCST 91234.56
    pICMSST 678.91
    vICMSST 12345.67
  end

  factory :icms_when_ICMS40, class: Nfe::Models::Taxes::ICMS do
    orig 0
    cst "40"
    vICMSDeson 23456.78
    motDesICMS 2
  end

  factory :icms_when_ICMS41, class: Nfe::Models::Taxes::ICMS do
    orig 0
    cst "41"
    vICMSDeson 23456.78
    motDesICMS 2
  end

  factory :icms_when_ICMS50, class: Nfe::Models::Taxes::ICMS do
    orig 0
    cst "50"
    vICMSDeson 23456.78
    motDesICMS 2
  end

  factory :icms_when_ICMS51, class: Nfe::Models::Taxes::ICMS do
    orig 2
    cst "51"
    modBC 3
    pRedBC 123.45
    vBC 12345.67
    pICMS 234.56
    vICMS 23456.78
  end

  factory :icms_when_ICMS60, class: Nfe::Models::Taxes::ICMS do
    orig 2
    cst "60"
    vBCSTRet 12345.67
    vICMSSTRet 23456.78
  end

  factory :icms_when_ICMS70, class: Nfe::Models::Taxes::ICMS do
    orig 2
    cst "70"
    modBC 3
    pRedBC 123.45
    vBC 12345.67
    pICMS 234.56
    vICMS 23456.78
    modBCST 5
    pMVAST 345.67
    pRedBCST 456.78
    vBCST 91234.56
    pICMSST 678.91
    vICMSST 12345.67
  end

  factory :icms_when_ICMS90, class: Nfe::Models::Taxes::ICMS do
    orig 2
    cst "90"
    modBC 3
    vBC 12345.67
    pRedBC 123.45
    pICMS 234.56
    vICMS 23456.78
    modBCST 5
    pMVAST 345.67
    pRedBCST 456.78
    vBCST 91234.56
    pICMSST 678.91
    vICMSST 12345.67
  end

  factory :icms_when_ICMS101, class: Nfe::Models::Taxes::ICMS do
    orig 2
    csosn "101"
    pCredSN 234.56
    vCredICMSSN 45678.90
  end

  factory :icms_when_ICMS102, class: Nfe::Models::Taxes::ICMS do
    orig 1
    csosn "102"
  end

  factory :icms_when_ICMS103, class: Nfe::Models::Taxes::ICMS do
    orig 1
    csosn "103"
  end

  factory :icms_when_ICMS300, class: Nfe::Models::Taxes::ICMS do
    orig 1
    csosn "300"
  end

  factory :icms_when_ICMS400, class: Nfe::Models::Taxes::ICMS do
    orig 1
    csosn "400"
  end

  factory :icms_when_ICMS201, class: Nfe::Models::Taxes::ICMS do
    orig 2
    csosn "201"
    modBCST 5
    pMVAST 345.67
    pRedBCST 456.78
    vBCST 91234.56
    pICMSST 678.91
    vICMSST 12345.67
    pCredSN 234.56
    vCredICMSSN 45678.90
  end

  factory :icms_when_ICMS202, class: Nfe::Models::Taxes::ICMS do
    orig 2
    csosn "202"
    modBCST 5
    pMVAST 345.67
    pRedBCST 456.78
    vBCST 91234.56
    pICMSST 678.91
    vICMSST 12345.67
  end

  factory :icms_when_ICMS203, class: Nfe::Models::Taxes::ICMS do
    orig 2
    csosn "203"
    modBCST 5
    pMVAST 345.67
    pRedBCST 456.78
    vBCST 91234.56
    pICMSST 678.91
    vICMSST 12345.67
  end

  factory :icms_when_ICMS500, class: Nfe::Models::Taxes::ICMS do
    orig 2
    csosn "500"
    vBCSTRet 12345.67
    vICMSSTRet 23456.78
  end

  factory :icms_when_ICMS900, class: Nfe::Models::Taxes::ICMS do
    orig 2
    csosn "900"
    modBC 3
    vBC 12345.67
    pRedBC 123.45
    pICMS 234.56
    vICMS 23456.78
    modBCST 5
    pMVAST 345.67
    pRedBCST 456.78
    vBCST 91234.56
    pICMSST 678.91
    vICMSST 12345.67
    pCredSN 234.56
    vCredICMSSN 45678.90
  end
end
