require "spec_helper"

describe Nfe::Helpers::SchemaValidator do
  let(:schema_path) { "lib/nfe/schemas/enviNFe_v3.10.xsd" }
  let(:xml) { File.read("spec/nfe/fixtures/nfe.xml") }
  let(:nfe) do
    nfe = Nfe::Models::NFe.new
    nfe.parse! xml
    Nfe::Services::Dispatch::EnviNFe.new(nfe, 1, "3.10").to_xml
  end

  subject { described_class.new(schema_path, nfe) }

  describe "#valid?" do
    context "when xml is valid" do
      it "returns true" do
        expect(subject).to be_valid
      end
    end

    context "when xml isn't valid" do
      let(:xml) { File.read("spec/nfe/fixtures/invalid_nfe.xml") }

      it "returns false" do
        expect(subject).to_not be_valid
      end

      it "fills an errors object" do
        subject.valid?
        expect(subject.errors).to be_any
      end
    end
  end
end
