require "spec_helper"

describe Nfe::Helpers::Signer do
  let(:certificate) { OpenSSL::X509::Certificate.new(File.read("spec/xmldsig/fixtures/certificate.cer")) }
  let(:private_key) { OpenSSL::PKey::RSA.new(File.read("spec/xmldsig/fixtures/key.pem")) }
  let(:object) { build(:inutNFe) }

  subject { described_class.new(certificate, private_key) }

  describe "#execute" do
    it "returns a signed object" do
      subject.execute(object, object.id)

      signed_document = Xmldsig::SignedDocument.new(object.to_xml)
      signature = signed_document.document.xpath("descendant::ds:Signature", Xmldsig::NAMESPACES)

      expect(signature.xpath("descendant::ds:DigestValue", Xmldsig::NAMESPACES).text).to_not be_blank
      expect(signature.xpath("descendant::ds:SignatureValue", Xmldsig::NAMESPACES).text).to_not be_blank
      expect(signature.xpath("descendant::ds:X509Certificate", Xmldsig::NAMESPACES).text).to_not be_blank
    end
  end
end
