require "spec_helper"

describe Nfe::Helpers::UfHelper do
  describe ".acronym" do
    context "when UF is Rondônia(11)" do
      it "returns RO" do
        expect(Nfe::Helpers::UfHelper.acronym(11)).to eql "RO"
      end
    end

    context "when UF is Acre(12)" do
      it "returns AC" do
        expect(Nfe::Helpers::UfHelper.acronym(12)).to eql "AC"
      end
    end

    context "when UF is Amazonas(13)" do
      it "returns AM" do
        expect(Nfe::Helpers::UfHelper.acronym(13)).to eql "AM"
      end
    end

    context "when UF is Roraima(14)" do
      it "returns RR" do
        expect(Nfe::Helpers::UfHelper.acronym(14)).to eql "RR"
      end
    end

    context "when UF is Pará(15)" do
      it "returns PA" do
        expect(Nfe::Helpers::UfHelper.acronym(15)).to eql "PA"
      end
    end

    context "when UF is Amapá(16)" do
      it "returns AP" do
        expect(Nfe::Helpers::UfHelper.acronym(16)).to eql "AP"
      end
    end

    context "when UF is Tocantins(17)" do
      it "returns TO" do
        expect(Nfe::Helpers::UfHelper.acronym(17)).to eql "TO"
      end
    end

    context "when UF is Maranhão(21)" do
      it "returns MA" do
        expect(Nfe::Helpers::UfHelper.acronym(21)).to eql "MA"
      end
    end

    context "when UF is Piauí(22)" do
      it "returns PI" do
        expect(Nfe::Helpers::UfHelper.acronym(22)).to eql "PI"
      end
    end

    context "when UF is Ceará(23)" do
      it "returns CE" do
        expect(Nfe::Helpers::UfHelper.acronym(23)).to eql "CE"
      end
    end

    context "when UF is Rio Grande do Norte(24)" do
      it "returns RN" do
        expect(Nfe::Helpers::UfHelper.acronym(24)).to eql "RN"
      end
    end

    context "when UF is Paraíba(25)" do
      it "returns PB" do
        expect(Nfe::Helpers::UfHelper.acronym(25)).to eql "PB"
      end
    end

    context "when UF is Pernambuco(26)" do
      it "returns PE" do
        expect(Nfe::Helpers::UfHelper.acronym(26)).to eql "PE"
      end
    end

    context "when UF is Alagoas(27)" do
      it "returns AL" do
        expect(Nfe::Helpers::UfHelper.acronym(27)).to eql "AL"
      end
    end

    context "when UF is Sergipe(28)" do
      it "returns SE" do
        expect(Nfe::Helpers::UfHelper.acronym(28)).to eql "SE"
      end
    end

    context "when UF is Bahia(29)" do
      it "returns BA" do
        expect(Nfe::Helpers::UfHelper.acronym(29)).to eql "BA"
      end
    end

    context "when UF is Minas Gerais(31)" do
      it "returns MG" do
        expect(Nfe::Helpers::UfHelper.acronym(31)).to eql "MG"
      end
    end

    context "when UF is Espírito Santo(32)" do
      it "returns ES" do
        expect(Nfe::Helpers::UfHelper.acronym(32)).to eql "ES"
      end
    end

    context "when UF is Rio de Janeiro(33)" do
      it "returns RJ" do
        expect(Nfe::Helpers::UfHelper.acronym(33)).to eql "RJ"
      end
    end

    context "when UF is São Paulo(35)" do
      it "returns SP" do
        expect(Nfe::Helpers::UfHelper.acronym(35)).to eql "SP"
      end
    end

    context "when UF is Paraná(41)" do
      it "returns PR" do
        expect(Nfe::Helpers::UfHelper.acronym(41)).to eql "PR"
      end
    end

    context "when UF is Santa Catarina(42)" do
      it "returns SC" do
        expect(Nfe::Helpers::UfHelper.acronym(42)).to eql "SC"
      end
    end

    context "when UF is Rio Grande do Sul(43)" do
      it "returns RS" do
        expect(Nfe::Helpers::UfHelper.acronym(43)).to eql "RS"
      end
    end

    context "when UF is Mato Grosso do Sul(50)" do
      it "returns MS" do
        expect(Nfe::Helpers::UfHelper.acronym(50)).to eql "MS"
      end
    end

    context "when UF is Mato Grosso(51)" do
      it "returns MT" do
        expect(Nfe::Helpers::UfHelper.acronym(51)).to eql "MT"
      end
    end

    context "when UF is Goiás(52)" do
      it "returns GO" do
        expect(Nfe::Helpers::UfHelper.acronym(52)).to eql "GO"
      end
    end

    context "when UF is Distrito Federal(53)" do
      it "returns DF" do
        expect(Nfe::Helpers::UfHelper.acronym(53)).to eql "DF"
      end
    end
  end

  describe ".code" do
    context "when UF is Rondônia(RO)" do
      it "returns 11" do
        expect(Nfe::Helpers::UfHelper.code("RO")).to eql 11
      end
    end

    context "when UF is Acre(AC)" do
      it "returns 12" do
        expect(Nfe::Helpers::UfHelper.code("AC")).to eql 12
      end
    end

    context "when UF is Amazonas(AM)" do
      it "returns 13" do
        expect(Nfe::Helpers::UfHelper.code("AM")).to eql 13
      end
    end

    context "when UF is Roraima(RR)" do
      it "returns 14" do
        expect(Nfe::Helpers::UfHelper.code("RR")).to eql 14
      end
    end

    context "when UF is Pará(PA)" do
      it "returns 15" do
        expect(Nfe::Helpers::UfHelper.code("PA")).to eql 15
      end
    end

    context "when UF is Amapá(AP)" do
      it "returns 16" do
        expect(Nfe::Helpers::UfHelper.code("AP")).to eql 16
      end
    end

    context "when UF is Tocantins(TO)" do
      it "returns 17" do
        expect(Nfe::Helpers::UfHelper.code("TO")).to eql 17
      end
    end

    context "when UF is Maranhão(MA)" do
      it "returns 21" do
        expect(Nfe::Helpers::UfHelper.code("MA")).to eql 21
      end
    end

    context "when UF is Piauí(PI)" do
      it "returns 22" do
        expect(Nfe::Helpers::UfHelper.code("PI")).to eql 22
      end
    end

    context "when UF is Ceará(CE)" do
      it "returns 23" do
        expect(Nfe::Helpers::UfHelper.code("CE")).to eql 23
      end
    end

    context "when UF is Rio Grande do Norte(RN)" do
      it "returns 24" do
        expect(Nfe::Helpers::UfHelper.code("RN")).to eql 24
      end
    end

    context "when UF is Paraíba(PB)" do
      it "returns 25" do
        expect(Nfe::Helpers::UfHelper.code("PB")).to eql 25
      end
    end

    context "when UF is Pernambuco(PE)" do
      it "returns 26" do
        expect(Nfe::Helpers::UfHelper.code("PE")).to eql 26
      end
    end

    context "when UF is Alagoas(AL)" do
      it "returns 27" do
        expect(Nfe::Helpers::UfHelper.code("AL")).to eql 27
      end
    end

    context "when UF is Sergipe(SE)" do
      it "returns 28" do
        expect(Nfe::Helpers::UfHelper.code("SE")).to eql 28
      end
    end

    context "when UF is Bahia(BA)" do
      it "returns 29" do
        expect(Nfe::Helpers::UfHelper.code("BA")).to eql 29
      end
    end

    context "when UF is Minas Gerais(MG)" do
      it "returns 31" do
        expect(Nfe::Helpers::UfHelper.code("MG")).to eql 31
      end
    end

    context "when UF is Espírito Santo(ES)" do
      it "returns 32" do
        expect(Nfe::Helpers::UfHelper.code("ES")).to eql 32
      end
    end

    context "when UF is Rio de Janeiro(RJ)" do
      it "returns 33" do
        expect(Nfe::Helpers::UfHelper.code("RJ")).to eql 33
      end
    end

    context "when UF is São Paulo(SP)" do
      it "returns 35" do
        expect(Nfe::Helpers::UfHelper.code("SP")).to eql 35
      end
    end

    context "when UF is Paraná(PR)" do
      it "returns 41" do
        expect(Nfe::Helpers::UfHelper.code("PR")).to eql 41
      end
    end

    context "when UF is Santa Catarina(SC)" do
      it "returns 42" do
        expect(Nfe::Helpers::UfHelper.code("SC")).to eql 42
      end
    end

    context "when UF is Rio Grande do Sul(RS)" do
      it "returns 43" do
        expect(Nfe::Helpers::UfHelper.code("RS")).to eql 43
      end
    end

    context "when UF is Mato Grosso do Sul(MS)" do
      it "returns 50" do
        expect(Nfe::Helpers::UfHelper.code("MS")).to eql 50
      end
    end

    context "when UF is Mato Grosso(MT)" do
      it "returns 51" do
        expect(Nfe::Helpers::UfHelper.code("MT")).to eql 51
      end
    end

    context "when UF is Goiás(GO)" do
      it "returns 52" do
        expect(Nfe::Helpers::UfHelper.code("GO")).to eql 52
      end
    end

    context "when UF is Distrito Federal(DF)" do
      it "returns 53" do
        expect(Nfe::Helpers::UfHelper.code("DF")).to eql  53
      end
    end
  end
end
