require "spec_helper"

class DooBigdecimal
  attr_accessor :zaz
end

describe Nfe::Helpers::XmlModel::AttributeBigdecimal do
  let(:doo) { DooBigdecimal.new }

  subject { described_class.new(:zaz) }

  describe "#parse" do
    let(:doc) { Nokogiri::XML("<zaz>99999999999.9999999999</zaz>") }

    before { subject.parse doo, doc }

    it "read like a bigdecimal attribute" do
      expect(doo.zaz).to eql BigDecimal("99999999999.9999999999")
    end
  end

  describe "#add_to_xml" do
    let(:xml) { Builder::XmlMarkup.new }
    before { doo.zaz = BigDecimal("99999999999.9999999999") }

    it "write like a float attribute" do
      subject.add_to_xml doo, xml, :zaz

      expect(xml.target!).to eq "<zaz>99999999999.9999999999</zaz>"
    end
  end
end
