require "spec_helper"

class DooEnumerize
  extend Enumerize
  enumerize :zaz, in: { aaa: 1 }
end

describe Nfe::Helpers::XmlModel::AttributeEnumerize do
  let(:doo) { DooEnumerize.new }

  subject { described_class.new(:zaz) }

  describe "#parse" do
    let(:doc) { Nokogiri::XML("<zaz>1</zaz>") }

    before { subject.parse doo, doc }

    it "read like an enumerize attribute" do
      expect(doo.zaz).to eql "aaa"
    end
  end

  describe "#add_to_xml" do
    let(:xml) { Builder::XmlMarkup.new }

    before { doo.zaz = :aaa }

    it "write like an enumerize attribute" do
      subject.add_to_xml doo, xml, :zaz

      expect(xml.target!).to eq "<zaz>1</zaz>"
    end
  end
end
