require "spec_helper"

class DooInteger
  attr_accessor :zaz
end

describe Nfe::Helpers::XmlModel::AttributeInteger do
  let(:doo) { DooInteger.new }

  subject { described_class.new(:zaz) }

  describe "#parse" do
    let(:doc) { Nokogiri::XML("<zaz>100</zaz>") }

    before { subject.parse doo, doc }

    it "read like an integer attribute" do
      expect(doo.zaz).to eql 100
    end
  end

  describe "#add_to_xml" do
    let(:xml) { Builder::XmlMarkup.new }

    before { doo.zaz = 100 }

    it "write like an integer attribute" do
      subject.add_to_xml doo, xml, :zaz

      expect(xml.target!).to eq "<zaz>100</zaz>"
    end
  end
end
