require "spec_helper"

class DooNodeattribute
  attr_accessor :zaz
end

describe Nfe::Helpers::XmlModel::AttributeNodeattribute do
  let(:doo) { DooNodeattribute.new }

  subject { described_class.new(:zaz) }

  describe "#parse" do
    let(:doc) { Nokogiri::XML("<doo zaz='value'>doo_value</doo>") }

    before { subject.parse doo, doc }

    it "read like an attribute" do
      expect(doo.zaz).to eql "value"
    end
  end

  describe "#add_to_xml" do
    let(:xml) { Builder::XmlMarkup.new }
    
    before { doo.zaz = "doo" }

    it "doesn't write nothing" do
      subject.add_to_xml doo, xml, :zaz

      expect(xml.target!).to be_blank
    end
  end
end
