require "spec_helper"

describe Nfe::Helpers::XmlModel::Factory do
  describe ".create" do
    context "when type is omitted" do
      it "returns an AttributeText instance" do
        attribute = described_class.create(:foo)
        expect(attribute).to be_an_instance_of Nfe::Helpers::XmlModel::AttributeText
      end
    end

    context "when type is :text" do
      let(:options) { { type: :text } }

      it "returns an AttributeText instance" do
        attribute = described_class.create(:foo, options)
        expect(attribute).to be_an_instance_of Nfe::Helpers::XmlModel::AttributeText
      end
    end

    context "when type is :bigdecimal" do
      let(:options) { { type: :bigdecimal } }

      it "returns an AttributeBigdecimal instance" do
        attribute = described_class.create(:foo, options)
        expect(attribute).to be_an_instance_of Nfe::Helpers::XmlModel::AttributeBigdecimal
      end
    end

    context "when type is :collection" do
      let(:options) { { type: :collection } }

      it "returns an AttributeCollection instance" do
        attribute = described_class.create(:foo, options)
        expect(attribute).to be_an_instance_of Nfe::Helpers::XmlModel::AttributeCollection
      end
    end

    context "when type is :date" do
      let(:options) { { type: :date } }

      it "returns an AttributeDate instance" do
        attribute = described_class.create(:foo, options)
        expect(attribute).to be_an_instance_of Nfe::Helpers::XmlModel::AttributeDate
      end
    end

    context "when type is :datetime" do
      let(:options) { { type: :datetime } }

      it "returns an AttributeDatetime instance" do
        attribute = described_class.create(:foo, options)
        expect(attribute).to be_an_instance_of Nfe::Helpers::XmlModel::AttributeDatetime
      end
    end

    context "when type is :enumerize" do
      let(:options) { { type: :enumerize } }

      it "returns an AttributeEnumerize instance" do
        attribute = described_class.create(:foo, options)
        expect(attribute).to be_an_instance_of Nfe::Helpers::XmlModel::AttributeEnumerize
      end
    end

    context "when type is :float" do
      let(:options) { { type: :float } }

      it "returns an AttributeFloat instance" do
        attribute = described_class.create(:foo, options)
        expect(attribute).to be_an_instance_of Nfe::Helpers::XmlModel::AttributeFloat
      end
    end

    context "when type is :integer" do
      let(:options) { { type: :integer } }

      it "returns an AttributeInteger instance" do
        attribute = described_class.create(:foo, options)
        expect(attribute).to be_an_instance_of Nfe::Helpers::XmlModel::AttributeInteger
      end
    end

    context "when type is :node" do
      let(:options) { { type: :node } }

      it "returns an AttributeNode instance" do
        attribute = described_class.create(:foo, options)
        expect(attribute).to be_an_instance_of Nfe::Helpers::XmlModel::AttributeNode
      end
    end

    context "when type is :attribute" do
      let(:options) { { type: :attribute } }

      it "returns an AttributeNodeattribute instance" do
        attribute = described_class.create(:foo, options)
        expect(attribute).to be_an_instance_of Nfe::Helpers::XmlModel::AttributeNodeattribute
      end
    end
  end
end
