require "spec_helper"

describe BigdecimalGreaterThanValidator do
  before(:each) do
    @validator = BigdecimalGreaterThanValidator.new(attributes: "bigdecimal")
    @mock = double("model")
    allow(@mock).to receive(:errors).and_return([])
    allow(@mock.errors).to receive(:messages).and_return({})
    allow(@mock.errors).to receive(:add) do |attribute, error|
       @mock.errors.messages[attribute] = [error]
    end
  end

  subject { @validator }

  context "when big decimal is valid" do
    it "doesn't add errors in model" do
      valid = BigDecimal("99_999_999_999.9999999999")

      subject.validate_each(@mock, "bigdecimal", valid)
      expect(@mock.errors.messages).to be_empty
    end
  end

  context "when big decimal is not valid" do
    it "add errors in model" do
      invalid = BigDecimal("100_000_000_000.9999999999")

      subject.validate_each(@mock, "bigdecimal", invalid)
      expect(@mock.errors.messages).to_not be_empty
    end
  end
end
