require "spec_helper"

describe Nfe::Models::Information::ObsContFisco do
  subject { build(:obsContFisco) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  it { is_expected.to validate_presence_of :xCampo }
  it { is_expected.to ensure_length_of(:xCampo).is_at_most(20) }

  it { is_expected.to validate_presence_of :xTexto }
  it { is_expected.to ensure_length_of(:xTexto).is_at_most(60) }

  context "when xml has all tags" do
    let(:xml) { xml  = "<xTexto>Observação</xTexto>" }

    describe "#to_xml" do
      it "returns a formatted xml" do
        expect(subject.to_xml).to eql xml
      end
    end

    describe "#parse!" do
      subject { Nfe::Models::Information::ObsContFisco.new }
      before { subject.parse!("<obs xCampo='123'>#{xml}</obs>") }

      it "parses xml values to itself" do
        expect(subject.xCampo).to eql "123"
        expect(subject.xTexto).to eql "Observação"
      end

      it { is_expected.to be_valid }
    end
  end
end
