require "spec_helper"

describe Nfe::Models::Itens::Arma do
  subject { build(:arma) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  it { is_expected.to validate_presence_of :tpArma }
  it { is_expected.to validate_presence_of :nSerie }
  it { is_expected.to validate_presence_of :nCano }
  it { is_expected.to validate_presence_of :descr }

  context "when xml has all tags" do
    let(:xml) do
      xml  = "<tpArma>0</tpArma>"
      xml += "<nSerie>123456</nSerie>"
      xml += "<nCano>789456</nCano>"
      xml += "<descr>Descrição completa da arma.</descr>"
    end

    describe "#to_xml" do
      it "returns a formatted xml" do
        expect(subject.to_xml).to eql xml
      end
    end

    describe "#parse!" do
      subject { Nfe::Models::Itens::Arma.new }
      before { subject.parse!("<root>#{xml}</root>") }

      it "parses xml values to itself" do
        expect(subject.tpArma).to eql "0"
        expect(subject.nSerie).to eql "123456"
        expect(subject.nCano).to eql "789456"
        expect(subject.descr).to eql "Descrição completa da arma."
      end

      it { is_expected.to be_valid }
    end
  end
end
