require "spec_helper"

describe Nfe::Models::NFeProc do
  let(:nfe) { build :NFe }
  let(:protNFe) { build :protNFe }

  subject { described_class.new(nfe, protNFe) }

  let(:xml) do
    "<nfeProc xmlns=\"http://www.portalfiscal.inf.br/nfe\" versao=\"3.10\">"\
      "#{build(:NFe).to_xml}"\
      "#{build(:protNFe).to_xml}"\
    "</nfeProc>"
  end

  describe "#to_xml" do
    it "returns a formatted xml" do
      expect(subject.to_xml).to eql xml
    end
  end
end
