require "spec_helper"

describe Nfe::Models::ProcInutNFe do
  let(:inutNFe) { build :inutNFe }
  let(:retInutNFe) { build :retInutNFe }

  subject { described_class.new(inutNFe, retInutNFe) }

  let(:xml) do
    "<ProcInutNFe xmlns=\"http://www.portalfiscal.inf.br/nfe\" versao=\"2.00\">"\
      "#{inutNFe.to_xml}"\
      "#{retInutNFe.to_xml}"\
    "</ProcInutNFe>"
  end

  describe "#to_xml" do
    it "returns a formatted xml" do
      expect(subject.to_xml).to eql xml
    end
  end
end
