shared_examples "a numeric TDec_0803 field" do |field|
  it { is_expected.to validate_numericality_of(field) }

  it "should require #{field} to be greater than or equal to zero" do
    fieldname = "#{field}="

    subject.send(fieldname, -1)
    subject.valid?

    expect(subject.errors[field].to_s).to match(/deve ser maior ou igual a 0/)
  end

  it "should require #{field} to be less than or equal to 99999999.999" do
    fieldname = "#{field}="

    subject.send(fieldname, 100_000_000.000)
    subject.valid?

    expect(subject.errors[field].to_s).to match(/deve ser menor ou igual a 99999999.999/)
  end
end
