shared_examples "a numeric TDec_1104Opc field" do |field|
  it_should_behave_like "a numeric TDec_1104Base field", field

  it { is_expected.to allow_value(nil).for(field) }
end

shared_examples "a numeric TDec_1104v field" do |field|
  it_should_behave_like "a numeric TDec_1104Base field", field

  it { is_expected.not_to allow_value(nil).for(field) }
end

shared_examples "a numeric TDec_1104 field" do |field|
  it_should_behave_like "a numeric TDec_1104v field", field
end

private
shared_examples "a numeric TDec_1104Base field" do |field|
  it { is_expected.to validate_numericality_of(field) }

  it "should require #{field} to be greater than or equal to zero" do
    fieldname = "#{field}="

    subject.send(fieldname, -1)
    subject.valid?

    expect(subject.errors[field].to_s).to match(/deve ser maior ou igual a 0/)
  end

  it "should require #{field} to be less than or equal to 99999999999.9999" do
    fieldname = "#{field}="

    subject.send(fieldname, 100_000_000_000.0000)
    subject.valid?

    expect(subject.errors[field].to_s).to match(/deve ser menor ou igual a 99999999999.9999/)
  end
end
