require "spec_helper"
require_relative "../shared_examples_for_tdec_1302"
require_relative "../shared_examples_for_tdec_0302"
require_relative "shared_examples_for_ICMS00"

describe Nfe::Models::Taxes::ICMS00 do
  subject { build(:icms00) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  it { is_expected.to validate_presence_of :orig }
  it { is_expected.to validate_numericality_of(:orig) }
  it { is_expected.to validate_inclusion_of(:orig).in_array([0, 1, 2]) }
  it { is_expected.to validate_presence_of :cst }
  it { is_expected.to respond_to "cst"}
  it { is_expected.to validate_presence_of :modBC }
  it { is_expected.to validate_numericality_of(:modBC) }
  it { is_expected.to validate_inclusion_of(:modBC).in_array([0, 1, 2, 3]) }

  it_should_behave_like "a numeric TDec_1302 field", :vBC
  it_should_behave_like "a numeric TDec_0302 field", :pICMS
  it_should_behave_like "a numeric TDec_1302 field", :vICMS

  it_should_behave_like "a ICMS00", :icms00, "", Nfe::Models::Taxes::ICMS00.new
end
