require "spec_helper"
require_relative "../shared_examples_for_tdec_1302"
require_relative "../shared_examples_for_tdec_0302"
require_relative "shared_examples_for_ICMS101"

describe Nfe::Models::Taxes::ICMS101 do
  subject { build(:icms101) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  it { is_expected.to validate_inclusion_of(:orig).in_array([0, 1, 2]) }
  it { is_expected.to validate_presence_of :csosn }
  it { is_expected.to respond_to "csosn" }

  it_should_behave_like "a numeric TDec_0302 field", :pCredSN
  it_should_behave_like "a numeric TDec_1302 field", :vCredICMSSN

  it_should_behave_like "a ICMS101", :icms101, "", Nfe::Models::Taxes::ICMS101.new
end
