require "spec_helper"
require_relative "shared_examples_for_ICMS00"
require_relative "shared_examples_for_ICMS10"
require_relative "shared_examples_for_ICMS20"
require_relative "shared_examples_for_ICMS30"
require_relative "shared_examples_for_ICMS40"
require_relative "shared_examples_for_ICMS41"
require_relative "shared_examples_for_ICMS50"
require_relative "shared_examples_for_ICMS51"
require_relative "shared_examples_for_ICMS60"
require_relative "shared_examples_for_ICMS70"
require_relative "shared_examples_for_ICMS90"
require_relative "shared_examples_for_ICMS101"
require_relative "shared_examples_for_ICMS102"
require_relative "shared_examples_for_ICMS103"
require_relative "shared_examples_for_ICMS300"
require_relative "shared_examples_for_ICMS400"
require_relative "shared_examples_for_ICMS201"
require_relative "shared_examples_for_ICMS202"
require_relative "shared_examples_for_ICMS203"
require_relative "shared_examples_for_ICMS500"
require_relative "shared_examples_for_ICMS900"

describe Nfe::Models::Taxes::ICMS do
  describe "#present?" do
    subject { Nfe::Models::Taxes::ICMS.new }

    context "when any attribute is present" do
      it { is_expected.to_not be_present }
    end

    context "when some attribute is present" do
      before { subject.cst = 10 }

      it { is_expected.to be_present }
    end
  end

  describe "#CSOSN" do
    it "is an alias to CST" do
      subject.csosn = 51
      subject.cst = 10
      expect(subject.csosn).to eq subject.cst
    end
  end

  describe "#CSOSN=" do
    it "is an alias to CST=" do
      subject.cst = 51
      subject.csosn = 10
      expect(subject.cst).to eq subject.csosn
    end
  end

  context "when ICMS00" do
    it_should_behave_like "a ICMS00", :icms_when_ICMS00, :ICMS00,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS10" do
    it_should_behave_like "a ICMS10", :icms_when_ICMS10, :ICMS10,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS20" do
    it_should_behave_like "a ICMS20", :icms_when_ICMS20, :ICMS20,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS30" do
    it_should_behave_like "a ICMS30", :icms_when_ICMS30, :ICMS30,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS40" do
    it_should_behave_like "a ICMS40", :icms_when_ICMS40, :ICMS40,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS41" do
    it_should_behave_like "a ICMS41", :icms_when_ICMS41, :ICMS40,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS50" do
    it_should_behave_like "a ICMS50", :icms_when_ICMS50, :ICMS40,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS51" do
    it_should_behave_like "a ICMS51", :icms_when_ICMS51, :ICMS51,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS60" do
    it_should_behave_like "a ICMS60", :icms_when_ICMS60, :ICMS60,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS70" do
    it_should_behave_like "a ICMS70", :icms_when_ICMS70, :ICMS70,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS90" do
    it_should_behave_like "a ICMS90", :icms_when_ICMS90, :ICMS90,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS101" do
    it_should_behave_like "a ICMS101", :icms_when_ICMS101, :ICMSSN101,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS102" do
    it_should_behave_like "a ICMS102", :icms_when_ICMS102, :ICMSSN102,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS103" do
    it_should_behave_like "a ICMS103", :icms_when_ICMS103, :ICMSSN102,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS300" do
    it_should_behave_like "a ICMS300", :icms_when_ICMS300, :ICMSSN102,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS400" do
    it_should_behave_like "a ICMS400", :icms_when_ICMS400, :ICMSSN102,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS201" do
    it_should_behave_like "a ICMS201", :icms_when_ICMS201, :ICMSSN201,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS202" do
    it_should_behave_like "a ICMS202", :icms_when_ICMS202, :ICMSSN202,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS203" do
    it_should_behave_like "a ICMS203", :icms_when_ICMS203, :ICMSSN202,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS500" do
    it_should_behave_like "a ICMS500", :icms_when_ICMS500, :ICMSSN500,
      Nfe::Models::Taxes::ICMS.new
  end

  context "when ICMS900" do
    it_should_behave_like "a ICMS900", :icms_when_ICMS900, :ICMSSN900,
      Nfe::Models::Taxes::ICMS.new
  end
end
