require "spec_helper"

describe Nfe::Models::Taxes::IPINT do
  subject { build(:ipiNT) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  it { is_expected.to validate_presence_of(:cst) }

  it do
    is_expected.to validate_inclusion_of(:cst).in_array(["01", "02", "03", "04", "05",
      "51", "52", "53", "54", "55"])
  end

  context "when xml has all tags" do
    let(:xml) do
      xml  = "<CST>01</CST>"
    end

    describe "#to_xml" do
      it "returns a formatted xml" do
        expect(subject.to_xml).to eql xml
      end
    end

    describe "#parse!" do
      subject { Nfe::Models::Taxes::IPINT.new }
      before { subject.parse!("<root>#{xml}</root>") }

      it "parses xml values to itself" do
        expect(subject.cst).to eql "01"
      end

      it { is_expected.to be_valid }
    end
  end
end
