require "spec_helper"
require_relative "../shared_examples_for_tdec_1302"
require_relative "../shared_examples_for_tdec_0302"
require_relative "shared_examples_for_COFINSAliq"
require_relative "shared_examples_for_PISAliq"

describe Nfe::Models::Taxes::PISCOFINSAliq do
  subject { described_class.new(nil, nil) }

  it { is_expected.to validate_presence_of(:cst) }
  it { is_expected.to validate_inclusion_of(:cst).in_array(["01", "02"]) }

  it_should_behave_like "a numeric TDec_1302 field", :vBC
  it_should_behave_like "a numeric TDec_0302 field", :tax
  it_should_behave_like "a numeric TDec_1302 field", :value

  it_should_behave_like "a COFINSAliq", :cofinsAliq, "",
    Nfe::Models::Taxes::PISCOFINSAliq.new("pCOFINS", "vCOFINS")

  it_should_behave_like "a PISAliq", :pisAliq, "",
    Nfe::Models::Taxes::PISCOFINSAliq.new("pPIS", "vPIS")
end
