require "spec_helper"
require_relative "../shared_examples_for_tdec_1302"
require_relative "../shared_examples_for_tdec_1204"
require_relative "../shared_examples_for_tdec_1104"
require_relative "../shared_examples_for_tdec_0302"
require_relative "shared_examples_for_COFINSOutr"
require_relative "shared_examples_for_PISOutr"

describe Nfe::Models::Taxes::PISCOFINSOutr do
  subject { described_class.new(nil, nil) }

  it { is_expected.to validate_presence_of(:cst) }

  it do
    is_expected.to validate_inclusion_of(:cst).in_array(["49", "50", "51", "52", "53",
      "54", "55", "56", "60", "62", "63", "64", "65", "66", "67", "70", "71",
      "72", "73", "74", "75", "98", "99"])
  end

  it_should_behave_like "a numeric TDec_1302Opc field", :vBC
  it_should_behave_like "a numeric TDec_0302Opc field", :tax
  it_should_behave_like "a numeric TDec_1204Opc field", :qBCProd
  it_should_behave_like "a numeric TDec_1104Opc field", :vAliqProd
  it_should_behave_like "a numeric TDec_1302 field", :value

  context "when cofins" do
    let(:new_object) { Nfe::Models::Taxes::PISCOFINSOutr.new("pCOFINS", "vCOFINS") }

    it_should_behave_like "a COFINSOutr", :cofinsOutr, ""
  end

  context "when pis" do
    let(:new_object) { Nfe::Models::Taxes::PISCOFINSOutr.new("pPIS", "vPIS") }

    it_should_behave_like "a PISOutr", :pisOutr, ""
  end
end
