require "spec_helper"
require_relative "../shared_examples_for_tdec_1302"
require_relative "../shared_examples_for_tdec_1204"
require_relative "../shared_examples_for_tdec_1104"
require_relative "shared_examples_for_COFINSQtde"
require_relative "shared_examples_for_PISQtde"

describe Nfe::Models::Taxes::PISCOFINSQtde do
  subject { described_class.new(nil) }

  it_should_behave_like "a numeric TDec_1204 field", :qBCProd
  it_should_behave_like "a numeric TDec_1104v field", :vAliqProd
  it_should_behave_like "a numeric TDec_1302 field", :value

  it { is_expected.to respond_to "cst"}
  it { is_expected.not_to respond_to "cst="}

  it_should_behave_like "a COFINSQtde", :cofinsQtde, "", described_class.new("vCOFINS")

  it_should_behave_like "a PISQtde", :pisQtde, "", described_class.new("vPIS")
end
