require "spec_helper"
require_relative "shared_examples_for_COFINSAliq"
require_relative "shared_examples_for_COFINSQtde"
require_relative "shared_examples_for_COFINSNT"
require_relative "shared_examples_for_COFINSOutr"
require_relative "shared_examples_for_PISAliq"
require_relative "shared_examples_for_PISQtde"
require_relative "shared_examples_for_PISNT"
require_relative "shared_examples_for_PISOutr"

describe Nfe::Models::Taxes::PISCOFINS do

  describe "#present?" do
    subject { described_class.new("cofins") }

    context "when any attribute is present" do
      it { is_expected.to_not be_present }
    end

    context "when some attribute is present" do
      before { subject.vBC = 1 }

      it { is_expected.to be_present }
    end
  end

  context "when aliq" do
    it_should_behave_like "a COFINSAliq", :cofins_when_aliq, :COFINSAliq,
      described_class.new("cofins")
  end

  context "when qtde" do
    it_should_behave_like "a COFINSQtde", :cofins_when_qtde, :COFINSQtde,
      described_class.new("cofins")
  end

  context "when nt" do
    it_should_behave_like "a COFINSNT", :cofins_when_nt, :COFINSNT,
      described_class.new("cofins")
  end

  context "when outr" do
    let(:new_object) { described_class.new("cofins") }
    it_should_behave_like "a COFINSOutr", :cofins_when_outr, :COFINSOutr
  end

  context "when aliq" do
    it_should_behave_like "a PISAliq", :pis_when_aliq, :PISAliq,
      described_class.new("pis")
  end

  context "when qtde" do
    it_should_behave_like "a PISQtde", :pis_when_qtde, :PISQtde,
      described_class.new("pis")
  end

  context "when nt" do
    it_should_behave_like "a PISNT", :pis_when_nt, :PISNT,
      described_class.new("pis")
  end

  context "when PIS" do
    context "when outr" do
      let(:new_object) { described_class.new("pis") }
      it_should_behave_like "a PISOutr", :pis_when_outr, :PISOutr
    end
  end
end
