shared_examples "a ICMS10" do |factory, root, new_object|
  subject { build(factory) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  context "when xml has all tags" do
    let(:xml) do
      xml  = ""
      xml += "<#{root}>" if root.present?
      xml += "<orig>2</orig>"
      xml += "<CST>10</CST>"
      xml += "<modBC>3</modBC>"
      xml += "<vBC>12345.67</vBC>"
      xml += "<pICMS>234.56</pICMS>"
      xml += "<vICMS>23456.78</vICMS>"
      xml += "<modBCST>5</modBCST>"
      xml += "<pMVAST>345.67</pMVAST>"
      xml += "<pRedBCST>456.78</pRedBCST>"
      xml += "<vBCST>91234.56</vBCST>"
      xml += "<pICMSST>678.91</pICMSST>"
      xml += "<vICMSST>12345.67</vICMSST>"
      xml += "</#{root}>" if root.present?

      xml
    end

    describe "#to_xml" do
      it "returns a formatted xml" do
        expect(subject.to_xml).to eql xml
      end
    end

    describe "#parse!" do
      subject { new_object }
      before { subject.parse!("<root>#{xml}</root>") }

      it "parses xml values to itself" do
        expect(subject.orig).to eql 2
        expect(subject.cst).to eql "10"
        expect(subject.modBC).to eql 3
        expect(subject.vBC).to eql 12345.67
        expect(subject.pICMS).to eql 234.56
        expect(subject.vICMS).to eql 23456.78
        expect(subject.modBCST).to eql 5
        expect(subject.pMVAST).to eql 345.67
        expect(subject.pRedBCST).to eql 456.78
        expect(subject.vBCST).to eql 91234.56
        expect(subject.pICMSST).to eql 678.91
        expect(subject.vICMSST).to eql 12345.67
      end

      it { is_expected.to be_valid }
    end
  end
end
