shared_examples "a ICMS101" do |factory, root, new_object|
  subject { build(factory) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  context "when xml has all tags" do
    let(:xml) do
      xml  = ""
      xml += "<#{root}>" if root.present?
      xml += "<orig>2</orig>"
      xml += "<CSOSN>101</CSOSN>"
      xml += "<pCredSN>234.56</pCredSN>"
      xml += "<vCredICMSSN>45678.90</vCredICMSSN>"
      xml += "</#{root}>" if root.present?

      xml
    end

    describe "#to_xml" do
      it "returns a formatted xml" do
        expect(subject.to_xml).to eql xml
      end
    end

    describe "#parse!" do
      subject { new_object }
      before { subject.parse!("<root>#{xml}</root>") }

      it "parses xml values to itself" do
        expect(subject.orig).to eql 2
        expect(subject.csosn).to eql "101"
        expect(subject.pCredSN).to eql 234.56
        expect(subject.vCredICMSSN).to eql 45678.90
      end

      it { is_expected.to be_valid }
    end
  end
end
