shared_examples "a ICMS20" do |factory, root, new_object|
  subject { build(factory) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  context "when xml has all tags" do
    let(:xml) do
      xml  = ""
      xml += "<#{root}>" if root.present?
      xml += "<orig>0</orig>"
      xml += "<CST>20</CST>"
      xml += "<modBC>2</modBC>"
      xml += "<pRedBC>123.45</pRedBC>"
      xml += "<vBC>123456789.01</vBC>"
      xml += "<pICMS>234.56</pICMS>"
      xml += "<vICMS>23456.78</vICMS>"
      xml += "</#{root}>" if root.present?

      xml
    end

    describe "#to_xml" do
      it "returns a formatted xml" do
        expect(subject.to_xml).to eql xml
      end
    end

    describe "#parse!" do
      subject { new_object }
      before { subject.parse!("<root>#{xml}</root>") }

      it "parses xml values to itself" do
        expect(subject.orig).to eql 0
        expect(subject.cst).to eql "20"
        expect(subject.modBC).to eql 2
        expect(subject.pRedBC).to eql 123.45
        expect(subject.vBC).to eql 123456789.01
        expect(subject.pICMS).to eql 234.56
        expect(subject.vICMS).to eql 23456.78
      end

      it { is_expected.to be_valid }
    end
  end
end
