shared_examples "a ICMS40" do |factory, root, new_object|
  subject { build(factory) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  context "when xml has all tags" do
    let(:xml) do
      xml  = ""
      xml += "<#{root}>" if root.present?
      xml += "<orig>0</orig>"
      xml += "<CST>40</CST>"
      xml += "<vICMSDeson>23456.78</vICMSDeson>"
      xml += "<motDesICMS>2</motDesICMS>"
      xml += "</#{root}>" if root.present?

      xml
    end

    describe "#to_xml" do
      it "returns a formatted xml" do
        expect(subject.to_xml).to eql xml
      end
    end

    describe "#parse!" do
      subject { new_object }
      before { subject.parse!("<root>#{xml}</root>") }

      it "parses xml values to itself" do
        expect(subject.orig).to eql 0
        expect(subject.cst).to eql "40"
        expect(subject.vICMSDeson).to eql 23456.78
        expect(subject.motDesICMS).to eql 2
      end

      it { is_expected.to be_valid }
    end
  end
end
