shared_examples "a ICMS400" do |factory, root, new_object|
  subject { build(factory) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  context "when xml has all tags" do
    let(:xml) do
      xml  = ""
      xml += "<#{root}>" if root.present?
      xml += "<orig>1</orig>"
      xml += "<CSOSN>400</CSOSN>"
      xml += "</#{root}>" if root.present?

      xml
    end

    describe "#to_xml" do
      it "returns a formatted xml" do
        expect(subject.to_xml).to eql xml
      end
    end

    describe "#parse!" do
      subject { new_object }
      before { subject.parse!("<root>#{xml}</root>") }

      it "parses xml values to itself" do
        expect(subject.orig).to eql 1
        expect(subject.csosn).to eql "400"
      end

      it { is_expected.to be_valid }
    end
  end
end
