shared_examples "a ICMS60" do |factory, root, new_object|
  subject { build(factory) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  context "when xml has all tags" do
    let(:xml) do
      xml  = ""
      xml += "<#{root}>" if root.present?
      xml += "<orig>2</orig>"
      xml += "<CST>60</CST>"
      xml += "<vBCSTRet>12345.67</vBCSTRet>"
      xml += "<vICMSSTRet>23456.78</vICMSSTRet>"
      xml += "</#{root}>" if root.present?

      xml
    end

    describe "#to_xml" do
      it "returns a formatted xml" do
        expect(subject.to_xml).to eql xml
      end
    end

    describe "#parse!" do
      subject { new_object }
      before { subject.parse!("<root>#{xml}</root>") }

      it "parses xml values to itself" do
        expect(subject.orig).to eql 2
        expect(subject.cst).to eql "60"
        expect(subject.vBCSTRet).to eql 12345.67
        expect(subject.vICMSSTRet).to eql 23456.78
      end

      it { is_expected.to be_valid }
    end
  end
end
