shared_examples "a PISAliq" do |factory, root, new_object|
  subject { build(factory) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  context "when xml has all tags" do
    let(:xml) do
      xml  = ""
      xml += "<#{root}>" if root.present?
      xml += "<CST>02</CST>"
      xml += "<vBC>12345.67</vBC>"
      xml += "<pPIS>98.76</pPIS>"
      xml += "<vPIS>23456.78</vPIS>"
      xml += "</#{root}>" if root.present?

      xml
    end

    describe "#to_xml" do
      it "returns a formatted xml" do
        expect(subject.to_xml).to eql xml
      end
    end

    describe "#parse!" do
      subject { new_object }
      before { subject.parse!("<root>#{xml}</root>") }

      it "parses xml values to itself" do
        expect(subject.cst).to eql "02"
        expect(subject.vBC).to eql 12_345.67
        expect(subject.tax).to eql 98.76
        expect(subject.value).to eql 23_456.78
      end

      it { is_expected.to be_valid }
    end
  end
end
