shared_examples "a PISQtde" do |factory, root, new_object|
  subject { build(factory) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  context "when xml has all tags" do
    let(:xml) do
      xml  = ""
      xml += "<#{root}>" if root.present?
      xml += "<CST>03</CST>"
      xml += "<qBCProd>12345.6789</qBCProd>"
      xml += "<vAliqProd>78901.2345</vAliqProd>"
      xml += "<vPIS>23456.78</vPIS>"
      xml += "</#{root}>" if root.present?

      xml
    end

    describe "#to_xml" do
      it "returns a formatted xml" do
        expect(subject.to_xml).to eql xml
      end
    end

    describe "#parse!" do
      subject { new_object }
      before { subject.parse!("<root>#{xml}</root>") }

      it "parses xml values to itself" do
        expect(subject.cst).to eql "03"
        expect(subject.qBCProd).to eql 12_345.6789
        expect(subject.vAliqProd).to eql 78_901.2345
        expect(subject.value).to eql 23_456.78
      end

      it { is_expected.to be_valid }
    end
  end
end
