require "spec_helper"
require_relative "shared_examples_for_operations"

describe Nfe::Operations::ConsultEmitter do
  let(:private_key) { OpenSSL::PKey::RSA.new(File.read("spec/nfe/fixtures/private-key.pem")) }
  let(:certificate) { OpenSSL::X509::Certificate.new(File.read("spec/nfe/fixtures/certificate.pem")) }

  context "when emitter is an individual" do
    let(:operation) { described_class.new(certificate, private_key, :test, "SC",
      :cpf, "11144477735") }

    it_should_behave_like "an operation", "retConsCad",
      Nfe::Services::Dispatch::ConsCad, Nfe::Services::Regress::RetConsCad
  end

  context "when emitter is a company (for IE)" do
    let(:operation) { described_class.new(certificate, private_key, :test, "SC",
      :ie, "253263131") }

    it_should_behave_like "an operation", "retConsCad",
      Nfe::Services::Dispatch::ConsCad, Nfe::Services::Regress::RetConsCad
  end

  context "when emitter is a company (for CNPJ)" do
    let(:operation) { described_class.new(certificate, private_key, :test, "SC",
      :cnpj, "01144012000152") }

    it_should_behave_like "an operation", "retConsCad",
      Nfe::Services::Dispatch::ConsCad, Nfe::Services::Regress::RetConsCad
  end
end
