require "spec_helper"
require_relative "shared_examples_for_operations"

describe Nfe::Operations::NfeSituation do
  let(:private_key) { OpenSSL::PKey::RSA.new(File.read("spec/nfe/fixtures/private-key.pem")) }
  let(:certificate) { OpenSSL::X509::Certificate.new(File.read("spec/nfe/fixtures/certificate.pem")) }
  let(:nfe_key) { "43140101144012000152550010000000011123456781" }
  let(:invalid_nfe_key) { "4314010114401200015255001000000001112345678" }

  let(:operation) { described_class.new(certificate, private_key, :test, nfe_key) }

  it_should_behave_like "an operation", "retConsSitNFe",
    Nfe::Services::Dispatch::ConsSitNFe, Nfe::Services::Regress::RetConsSitNFe
end
