require "spec_helper"
require_relative "shared_examples_for_operations"

describe Nfe::Operations::ServiceStatus do
  let(:private_key) { OpenSSL::PKey::RSA.new(File.read("spec/nfe/fixtures/private-key.pem")) }
  let(:certificate) { OpenSSL::X509::Certificate.new(File.read("spec/nfe/fixtures/certificate.pem")) }
  let(:operation) { described_class.new(certificate, private_key, :test, "SC") }

  it_should_behave_like "an operation", "retConsStatServ",
    Nfe::Services::Dispatch::ConsStatServ, Nfe::Services::Regress::RetConsStatServ
end
