require "spec_helper"

describe Nfe::Services::Dispatch::ConsSitNFe do
  subject { build(:consSitNFe) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  it { is_expected.to ensure_length_of(:versao).is_equal_to(4) }

  it { is_expected.to ensure_length_of(:chNFe).is_equal_to(44) }

  it { is_expected.to ensure_length_of(:uf).is_equal_to(2) }

  let(:xml) do
    xml  = "<consSitNFe xmlns=\"http://www.portalfiscal.inf.br/nfe\" versao=\"2.00\">"
    xml += "<tpAmb>2</tpAmb>"
    xml += "<xServ>CONSULTAR</xServ>"
    xml += "<chNFe>42111111111111111111111111111111111111111111</chNFe>"
    xml += "</consSitNFe>"
  end

  describe "#to_xml" do
    it "returns a formatted xml" do
      expect(subject.to_xml).to eql xml
    end
  end
end
