require "spec_helper"

describe Nfe::Services::Dispatch::ConsStatServ do
  subject { build(:consStatServ) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  it { is_expected.to ensure_length_of(:versao).is_equal_to(4) }

  let(:xml) do
    xml  = "<consStatServ xmlns=\"http://www.portalfiscal.inf.br/nfe\" versao=\"2.00\">"
    xml += "<tpAmb>2</tpAmb>"
    xml += "<cUF>42</cUF>"
    xml += "<xServ>STATUS</xServ>"
    xml += "</consStatServ>"
  end

  describe "#to_xml" do
    it "returns a formatted xml" do
      expect(subject.to_xml).to eql xml
    end
  end
end
