require "spec_helper"

describe Nfe::Services::Dispatch::DetEventoCC do
  subject { build(:detEventoCC) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  it { is_expected.to ensure_length_of(:versao).is_equal_to(4) }

  it { is_expected.to ensure_length_of(:xCorrecao).is_at_least(15).is_at_most(1000) }

  describe '#kind' do
    subject { super().kind }
    it { is_expected.to eq :cce }
  end

  describe '#tpEvent' do
    subject { super().tpEvent }
    it { is_expected.to eq 110110 }
  end  

  let(:xml) do
    xml  = "<detEvento versao=\"1.00\">"
    xml +=   "<descEvento>Carta de Correcao</descEvento>"
    xml +=   "<xCorrecao>Erro de Digitação</xCorrecao>"
    xml +=   "<xCondUso>A Carta de Correcao e disciplinada pelo paragrafo "
    xml +=   "1o-A do art. 7o do Convenio S/N, de 15 de dezembro de 1970 e pode"
    xml +=   " ser utilizada para regularizacao de erro ocorrido na emissao de "
    xml +=   "documento fiscal, desde que o erro nao esteja relacionado com: "
    xml +=   "I - as variaveis que determinam o valor do imposto tais como: "
    xml +=   "base de calculo, aliquota, diferenca de preco, quantidade, valor "
    xml +=   "da operacao ou da prestacao; II - a correcao de dados cadastrais "
    xml +=   "que implique mudanca do remetente ou do destinatario; III - a "
    xml +=   "data de emissao ou de saida.</xCondUso>"
    xml += "</detEvento>"
  end

  describe "#to_xml" do
    it "returns a formatted xml" do
      expect(subject.to_xml).to eql xml
    end
  end
end
