require "spec_helper"

describe Nfe::Services::Dispatch::DetEventoCancel do
  subject { build(:detEventoCancel) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  it { is_expected.to ensure_length_of(:versao).is_equal_to(4) }

  it { is_expected.to ensure_length_of(:nProt).is_equal_to(15) }

  it { is_expected.to ensure_length_of(:xJust).is_at_least(15).is_at_most(255) }

  describe '#kind' do
    subject { super().kind }
    it { is_expected.to eq :nfe_cancel }
  end

  describe '#tpEvent' do
    subject { super().tpEvent }
    it { is_expected.to eq 110111 }
  end  

  let(:xml) do
    xml  = "<detEvento versao=\"1.00\">"
    xml +=   "<descEvento>Cancelamento</descEvento>"
    xml +=   "<nProt>123456789012345</nProt>"
    xml +=   "<xJust>Erro de Digitação</xJust>"
    xml += "</detEvento>"
  end

  describe "#to_xml" do
    it "returns a formatted xml" do
      expect(subject.to_xml).to eql xml
    end
  end
end
