require "spec_helper"

describe Nfe::Services::Dispatch::EnvEvento do
  subject { build(:envEvento) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  it { is_expected.to ensure_length_of(:idLote).is_at_least(1).is_at_most(15) }

  context "when evento is invalid" do
    it "returns an error on evento" do
      subject.evento = build(:evento, uf: nil)
      subject.valid?

      expect(subject.errors.to_json).to match(/evento/)
    end
  end

  let(:xml) do
    xml  = "<envEvento xmlns=\"http://www.portalfiscal.inf.br/nfe\" versao=\"1.00\">"
    xml +=   "<idLote>1</idLote>"
    xml +=   build(:evento).to_xml
    xml += "</envEvento>"
  end

  describe "#to_xml" do
    it "returns a formatted xml" do
      expect(subject.to_xml).to eql xml
    end
  end
end
