require "spec_helper"

describe Nfe::Services::Dispatch::EnviNFe do
  subject { build(:enviNFe) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  it { is_expected.to ensure_length_of(:lote).is_at_least(1).is_at_most(15) }

  it { is_expected.to ensure_length_of(:versao).is_equal_to(4) }

  let(:xml) do
    xml  = "<enviNFe xmlns=\"http://www.portalfiscal.inf.br/nfe\" versao=\"3.10\">"
    xml += "<idLote>200602220000001</idLote>"
    xml += "<indSinc>1</indSinc>"
    xml += build(:NFe).to_xml
    xml += "</enviNFe>"
  end

  describe "#to_xml" do
    it "returns a formatted xml" do
      expect(subject.to_xml).to eql xml
    end
  end
end
