require "spec_helper"

describe Nfe::Services::Regress::InfCad do
  let(:xml) do
      xml = "<IE>253263131</IE>"
      xml += "<CNPJ>01144012000152</CNPJ>"
      xml += "<CPF>11144477735</CPF>"
      xml += "<UF>SC</UF>"
      xml += "<cSit>1</cSit>"
      xml += "<indCredNFe>1</indCredNFe>"
      xml += "<indCredCTe>1</indCredCTe>"
      xml += "<xNome>Razão Social</xNome>"
      xml += "<xFant>Nome Fantasia</xFant>"
      xml += "<xRedApur>Regime</xRedApur>"
      xml += "<CNAE>1234567</CNAE>"
      xml += "<dIniAtiv>1</dIniAtiv>"
      xml += "<dUltSit>1</dUltSit>"
      xml += "<dBaixa>1</dBaixa>"
      xml += "<IEUnica>253263131</IEUnica>"
      xml += "<IEAtual>253263131</IEAtual>"
      xml += "<ender>"
      xml +=   "<xLgr>Rua Geral</xLgr>"
      xml +=   "<nro>5</nro>"
      xml +=   "<xCpl>Apartamento</xCpl>"
      xml +=   "<xBairro>Centro</xBairro>"
      xml +=   "<cMun>4203709</cMun>"
      xml +=   "<xMun>Tijucas</xMun>"
      xml +=   "<CEP>88200000</CEP>"
      xml += "</ender>"
    end

  describe "#parse!" do
    before { subject.parse!("<root>#{xml}</root>") }

    it "parses xml values to itself" do
      expect(subject.ie).to eql "253263131"
      expect(subject.cnpj ).to eql "01144012000152"
      expect(subject.cpf).to eql "11144477735"
      expect(subject.uf).to eql "SC"
      expect(subject.cSit).to eql "1"
      expect(subject.indCredNFe).to eql "1"
      expect(subject.indCredCTe).to eql "1"
      expect(subject.xNome).to eql "Razão Social"
      expect(subject.xFant).to eql "Nome Fantasia"
      expect(subject.xRedApur).to eql "Regime"
      expect(subject.cnae).to eql "1234567"
      expect(subject.dIniAtiv).to eql "1"
      expect(subject.dUltSit).to eql "1"
      expect(subject.dBaixa).to eql "1"
      expect(subject.ieUnica).to eql "253263131"
      expect(subject.ieAtual).to eql "253263131"
      expect(subject.xLgr).to eql "Rua Geral"
      expect(subject.nro).to eql "5"
      expect(subject.xCpl).to eql "Apartamento"
      expect(subject.xBairro).to eql "Centro"
      expect(subject.cMun).to eql "4203709"
      expect(subject.xMun).to eql "Tijucas"
      expect(subject.cep).to eql "88200000"
    end
  end
end
