require "spec_helper"

describe Nfe::Services::Regress::RetConsCad do
  let(:xml) do
      xml = "<root>"
      xml =   "<retConsCad versao='2.00'>"
      xml +=    "<infCons>"
      xml +=      "<verAplic>SVAN</verAplic>"
      xml +=      "<cStat>123</cStat>"
      xml +=      "<xMotivo>Status da Resposta</xMotivo>"
      xml +=      "<UF>SC</UF>"
      xml +=      "<IE>253263131</IE>"
      xml +=      "<CNPJ>01144012000152</CNPJ>"
      xml +=      "<CPF>11144477735</CPF>"
      xml +=      "<dhCons>2013-12-05T12:34:56-03:00</dhCons>"
      xml +=      "<cUF>43</cUF>"
      xml +=      "<infCad>"
      xml +=        "<IE>253263131</IE>"
      xml +=        "<CNPJ>01144012000152</CNPJ>"
      xml +=        "<CPF>11144477735</CPF>"
      xml +=        "<UF>SC</UF>"
      xml +=        "<cSit>1</cSit>"
      xml +=        "<indCredNFe>1</indCredNFe>"
      xml +=        "<indCredCTe>1</indCredCTe>"
      xml +=        "<xNome>Razão Social</xNome>"
      xml +=        "<xFant>Nome Fantasia</xFant>"
      xml +=        "<xRedApur>Regime</xRedApur>"
      xml +=        "<CNAE>1234567</CNAE>"
      xml +=        "<dIniAtiv>1</dIniAtiv>"
      xml +=        "<dUltSit>1</dUltSit>"
      xml +=        "<dBaixa>1</dBaixa>"
      xml +=        "<IEUnica>253263131</IEUnica>"
      xml +=        "<IEAtual>253263131</IEAtual>"
      xml +=        "<ender>"
      xml +=          "<xLgr>Rua Geral</xLgr>"
      xml +=          "<nro>5</nro>"
      xml +=          "<xCpl>Apartamento</xCpl>"
      xml +=          "<xBairro>Centro</xBairro>"
      xml +=          "<cMun>4203709</cMun>"
      xml +=          "<xMun>Tijucas</xMun>"
      xml +=          "<CEP>88200000</CEP>"
      xml +=        "</ender>"
      xml +=      "</infCad>"
      xml +=    "</infCons>"
      xml +=   "</retConsCad>"
      xml += "</root>"

    end

  describe "#new" do
    subject { described_class.new("#{xml}") }

    it "parses xml values to itself" do
        expect(subject.versao).to eql "2.00"
        expect(subject.verAplic).to eql "SVAN"
        expect(subject.cStat).to eql "123"
        expect(subject.xMotivo).to eql "Status da Resposta"
        expect(subject.uf).to eql "SC"
        expect(subject.ie).to eql "253263131"
        expect(subject.cnpj ).to eql "01144012000152"
        expect(subject.cpf).to eql "11144477735"
        expect(subject.dhCons).to eql DateTime.strptime("2013-12-05T12:34:56-03:00", "%Y-%m-%dT%H:%M:%S%:z")
        expect(subject.cUF).to eql "43"
        expect(subject.infCad.size).to eql 1
    end
  end
end
