require "spec_helper"

describe Nfe::Services::Regress::RetConsSitNFe do

  let(:xml) do
    xml  = "<retConsSitNFe versao=\"2.01\" xmlns=\"http://www.portalfiscal.inf.br/nfe\">"
    xml +=   "<tpAmb>2</tpAmb>"
    xml +=   "<verAplic>SVRS20131127084734</verAplic>"
    xml +=   "<cStat>100</cStat>"
    xml +=   "<xMotivo>Autorizado o uso da NF-e</xMotivo>"
    xml +=   "<cUF>42</cUF>"
    xml +=   "<chNFe>42140301144012000152550010000000021458965750</chNFe>"
    xml +=   "<protNFe versao=\"2.00\">"
    xml +=     "<infProt Id=\"ID342140000245084\">"
    xml +=       "<tpAmb>2</tpAmb>"
    xml +=       "<verAplic>SVRS20140401105551</verAplic>"
    xml +=       "<chNFe>42140301144012000152550010000000021458965750</chNFe>"
    xml +=       "<dhRecbto>2014-04-07T11:50:44-03:00</dhRecbto>"
    xml +=       "<nProt>342140000245084</nProt>"
    xml +=       "<digVal>M7Mu1XMg2i9/0R9IoUncq5MjT+8=</digVal>"
    xml +=       "<cStat>100</cStat>"
    xml +=       "<xMotivo>Autorizado o uso da NF-e</xMotivo>"
    xml +=     "</infProt>"
    xml +=   "</protNFe>"
    xml +=   "<retCancNFe>123456789</retCancNFe>"
    xml +=   "<procEventoNFe>123456789</procEventoNFe>"
    xml += "</retConsSitNFe>"
  end

  describe "#new" do
    subject { described_class.new(xml) }

    it "parses xml values to itself" do
      expect(subject.versao).to eql "2.01"
      expect(subject.tpAmb).to eql "2"
      expect(subject.verAplic).to eql "SVRS20131127084734"
      expect(subject.cStat).to eql "100"
      expect(subject.xMotivo).to eql "Autorizado o uso da NF-e"
      expect(subject.cUF).to eql "42"
      expect(subject.chNFe).to eql "42140301144012000152550010000000021458965750"
      expect(subject.protNFe.cStat).to eql 100
      expect(subject.retCancNFe).to eql "123456789"
      expect(subject.procEventoNFe).to eql "123456789"
    end
  end
end
