require "spec_helper"

describe Nfe::Services::Regress::RetConsStatServ do
  let(:xml) do
    xml  = "<root versao='2.00'>"
    xml += "<tpAmb>1</tpAmb>"
    xml += "<verAplic>SVAN</verAplic>"
    xml += "<cStat>123</cStat>"
    xml += "<xMotivo>Resposta do Serviço</xMotivo>"
    xml += "<cUF>43</cUF>"
    xml += "<dhRecbto>2014-02-05T13:21:00-03:00</dhRecbto>"
    xml += "<tMed>1.23</tMed>"
    xml += "<dhRetorno>2013-12-05T12:34:56-03:00</dhRetorno>"
    xml += "<xObs>Observação do serviço</xObs>"
    xml += "</root>"
  end

  describe "#new" do
    subject { described_class.new(xml) }

    it "parses xml values to itself" do
      expect(subject.versao).to eql "2.00"
      expect(subject.tpAmb).to eql "1"
      expect(subject.verAplic).to eql "SVAN"
      expect(subject.cStat).to eql "123"
      expect(subject.xMotivo).to eql "Resposta do Serviço"
      expect(subject.cUF).to eql "43"
      expect(subject.dhRecbto).to eql DateTime.strptime("2014-02-05T13:21:00-03:00", "%Y-%m-%dT%H:%M:%S%:z")
      expect(subject.tMed).to eql "1.23"
      expect(subject.dhRetorno).to eql DateTime.strptime("2013-12-05T12:34:56-03:00", "%Y-%m-%dT%H:%M:%S%:z")
      expect(subject.xObs).to eql "Observação do serviço"
    end
  end
end
