require "spec_helper"

describe Nfe::Services::Regress::RetEnvEvento do
  let(:xml) do
    xml  = "<retEnvEvento versao=\"1.00\" xmlns=\"http://www.portalfiscal.inf.br/nfe\">"
    xml +=   "<idLote>1</idLote>"
    xml +=   "<tpAmb>1</tpAmb>"
    xml +=   "<verAplic>RS20131127100609</verAplic>"
    xml +=   "<cOrgao>43</cOrgao>"
    xml +=   "<cStat>128</cStat>"
    xml +=   "<xMotivo>Lote de Evento Processado</xMotivo>"
    xml +=   "<retEvento versao=\"1.00\">"
    xml +=     "<infEvento>"
    xml +=       "<tpAmb>2</tpAmb>"
    xml +=       "<verAplic>RS20131127100609</verAplic>"
    xml +=       "<cOrgao>43</cOrgao>"
    xml +=       "<cStat>297</cStat>"
    xml +=       "<xMotivo>Rejeicao: Assinatura difere do calculado</xMotivo>"
    xml +=       "<chNFe>31101203913809000100550010000000221000000220</chNFe>"
    xml +=       "<tpEvento>110111</tpEvento>"
    xml +=       "<nSeqEvento>1</nSeqEvento>"
    xml +=       "<dhRegEvento>2014-02-06T16:46:26-02:00</dhRegEvento>"
    xml +=     "</infEvento>"
    xml +=   "</retEvento>"
    xml += "</retEnvEvento>"
  end

  describe "#parse!" do
    before { subject.parse! xml }

    it "parses xml values to itself" do
      expect(subject.versao).to eql "1.00"
      expect(subject.idLote).to eql "1"
      expect(subject.tpAmb).to eql "production"
      expect(subject.verAplic).to eql "RS20131127100609"
      expect(subject.cOrgao).to eql "43"
      expect(subject.cStat).to eql 128
      expect(subject.xMotivo).to eql "Lote de Evento Processado"
      expect(subject.retEvento).to be_valid
    end

    it { is_expected.to be_valid }
  end
end
