require "spec_helper"

describe Nfe::Services::Regress::RetEnviNFe do
  let(:xml) do
    xml  = "<root versao='2.00'>"
    xml += "<tpAmb>1</tpAmb>"
    xml += "<verAplic>SCAN</verAplic>"
    xml += "<cStat>123</cStat>"
    xml += "<xMotivo>Motivo</xMotivo>"
    xml += "<cUF>43</cUF>"
    xml += "<dhRecbto>2013-12-05T12:34:56-03:00</dhRecbto>"
    xml += "<protNFe versao=\"2.00\">"
    xml +=   "<infProt Id=\"ID342140000245084\">"
    xml +=     "<tpAmb>2</tpAmb>"
    xml +=     "<verAplic>SVRS20140401105551</verAplic>"
    xml +=     "<chNFe>42140301144012000152550010000000021458965750</chNFe>"
    xml +=     "<dhRecbto>2014-04-07T11:50:44-03:00</dhRecbto>"
    xml +=     "<nProt>342140000245084</nProt>"
    xml +=     "<digVal>M7Mu1XMg2i9/0R9IoUncq5MjT+8=</digVal>"
    xml +=     "<cStat>100</cStat>"
    xml +=     "<xMotivo>Autorizado o uso da NF-e</xMotivo>"
    xml +=   "</infProt>"
    xml += "</protNFe>"
    xml += "</root>"
  end

  describe "#parse!" do
    before { subject.parse! xml }

    it "parses xml values to itself" do
      expect(subject.versao).to eql "2.00"
      expect(subject.tpAmb).to eql "1"
      expect(subject.verAplic).to eql "SCAN"
      expect(subject.cStat).to eql 123
      expect(subject.xMotivo).to eql "Motivo"
      expect(subject.cUF).to eql "43"
      expect(subject.dhRecbto).to eql DateTime.strptime("2013-12-05T12:34:56-03:00",
        "%Y-%m-%dT%H:%M:%S%:z")
      expect(subject.protNFe.cStat).to eql 100
    end

    it { is_expected.to be_valid }
  end
end
