require "spec_helper"
require "savon/mock/spec_helper"

describe Nfe::Webservices::ClientSoap do
  include Savon::SpecHelper

  let(:url) { "https://nfe.svrs.rs.gov.br/ws/NfeStatusServico/NfeStatusServico2.asmx?wsdl" }
  let(:wsdl) { File.read("spec/nfe/webservices/fixtures/nfe_status_servico2.wsdl") }
  let(:service) { :nfe_status_servico_nf2 }

  let(:wsinfo) do
    wsinfo = Nfe::Webservices::Wsinfo::ServiceStatus.new(nil,nil)
    allow(wsinfo).to receive(:url)
    allow(wsinfo).to receive(:version)
    wsinfo
  end

  before { stub_request(:get, url).to_return(status: 200, body: wsdl) }
  before { savon.mock! }
  after { savon.unmock! }

  describe "#call" do
    it "invoque a client soap" do
      savon.expects(service).with(message: "foo").returns("baz")

      client = described_class.new(nil, nil, wsinfo)

      response = client.call("foo")
      expect(response).to be_successful
    end
  end
end
