require "spec_helper"

describe Nfe::Webservices::Wsinfo::Event do
  subject { described_class.new(nil, nil, nil)}

  before do
    allow_any_instance_of(Nfe::Webservices::Wsinfo::WsdlFinder).
      to receive(:event).and_return("foo")
  end

  describe '#service' do
    subject { super().service }
    it { is_expected.to eq :nfe_recepcao_evento }
  end

  describe '#namespace' do
    subject { super().namespace }
    it do
    is_expected.to eq "http://www.portalfiscal.inf.br/nfe/wsdl/RecepcaoEvento"
  end
  end

  describe '#url' do
    subject { super().url }
    it { is_expected.to eq "foo" }
  end

  describe '#version' do
    subject { super().version }
    it { is_expected.to eq "1.00" }
  end

  describe "#schema" do
    context "when event's kind is cce" do
      subject { described_class.new(nil, nil, :cce)}

      it "returns cce's schema validation" do
        expect(subject.schema).to eq "envCCe_v1.00.xsd"
      end
    end

    context "when event's kind is nfe_cancel)" do
      subject { described_class.new(nil, nil, :nfe_cancel)}

      it "returns nfe_cancel's schema validation" do
        expect(subject.schema).to eq "envEventoCancNFe_v1.00.xsd"
      end
    end
  end
end
