require "spec_helper"

describe Nfe::Webservices::Wsinfo::Factory do
  shared_examples "expects for create_wsdl" do |environment, uf, klass_expected|
    context "when environment is #{environment}" do
      context "when UF is #{uf}" do
        it "returns #{klass_expected.name} instance" do
          wsdl = Nfe::Webservices::Wsinfo::Factory.create_wsdl(environment, uf)
          expect(wsdl).to be_an_instance_of klass_expected
        end
      end
    end
  end

  describe ".create_wsdl" do
    [:test, :production].each do |environment|
      ["AM","BA","CE","GO","MG","MS","MT","PE","PR","RS","SP"].each do | uf |
        include_examples "expects for create_wsdl", environment, uf,
          Nfe::Webservices::Wsinfo.const_get("#{environment.capitalize}").
            const_get("#{uf.capitalize}")
      end

      ["ES", "MA", "PA", "PI"].each do | uf |
        include_examples "expects for create_wsdl", environment, uf,
          Nfe::Webservices::Wsinfo.const_get("#{environment.capitalize}")::Svan
      end

      ["AC","AL","AP","DF","PB","RJ","RN","RO","RR","SE","TO","SC"].each do | uf |
        include_examples "expects for create_wsdl", environment, uf,
          Nfe::Webservices::Wsinfo.const_get("#{environment.capitalize}")::Svrs
      end
    end

    context "when uf is invalid" do
      it "is returns an error" do
        expect{ described_class.create_wsdl(:production, "XX")
          }.to raise_error ArgumentError
            I18n.t("webservice.environment_uf.invalid", environment: :x, uf: "SC")
      end
    end

    context "when environment is invalid" do
      it "is returns an error" do
        expect{ described_class.create_wsdl(:x, "SC")
          }.to raise_error ArgumentError,
            I18n.t("webservice.environment_uf.invalid", environment: :x, uf: "SC")
      end
    end
  end
end
