require "spec_helper"

describe Nfe::Webservices::Wsinfo::NfeDisenable do
  subject { described_class.new(nil, nil)}

  before do
    allow_any_instance_of(Nfe::Webservices::Wsinfo::WsdlFinder).
      to receive(:disenable).and_return("foo")
  end

  describe '#service' do
    subject { super().service }
    it { is_expected.to eq :nfe_inutilizacao_nf2 }
  end

  describe '#namespace' do
    subject { super().namespace }
    it do
    is_expected.to eq "http://www.portalfiscal.inf.br/nfe/wsdl/NfeInutilizacao2"
  end
  end

  describe '#url' do
    subject { super().url }
    it { is_expected.to eq "foo" }
  end

  describe '#version' do
    subject { super().version }
    it { is_expected.to eq "3.10" }
  end

  describe '#schema' do
    subject { super().schema }
    it { is_expected.to eq "inutNFe_v3.10.xsd" }
  end
end
