require "spec_helper"

describe Nfe::Webservices::Wsinfo::WsdlFinder do
  describe "#authorize" do
    it "returns the address of authorize wsdl of an UF" do
      allow_any_instance_of(Nfe::Webservices::Wsinfo::Production::Sp).
      to receive(:authorize).and_return(:wsdl_sp)

      expect(subject.authorize(:production, "SP")).to eql :wsdl_sp
    end
  end

  describe "#situation" do
    it "returns the address of situation wsdl of an UF" do
      allow_any_instance_of(Nfe::Webservices::Wsinfo::Production::Sp).
      to receive(:situation).and_return(:wsdl_sp)

      expect(subject.situation(:production, "SP")).to eql :wsdl_sp
    end
  end

  describe "#service_status" do
    it "returns the address of service_status wsdl of an UF" do
      allow_any_instance_of(Nfe::Webservices::Wsinfo::Production::Sp).
      to receive(:service_status).and_return(:wsdl_sp)

      expect(subject.service_status(:production, "SP")).to eql :wsdl_sp
    end
  end

  describe "#disenable" do
    it "returns the address of disenable wsdl of an UF" do
      allow_any_instance_of(Nfe::Webservices::Wsinfo::Production::Sp).
      to receive(:disenable).and_return(:wsdl_sp)

      expect(subject.disenable(:production, "SP")).to eql :wsdl_sp
    end
  end

  describe "#event" do
    it "returns the address of event wsdl of an UF" do
      allow_any_instance_of(Nfe::Webservices::Wsinfo::Production::Sp).
      to receive(:event).and_return(:wsdl_sp)

      expect(subject.event(:production, "SP")).to eql :wsdl_sp
    end
  end

  describe "#consult_emitter" do
    it "returns the address of consult_emitter wsdl of an UF" do
      allow_any_instance_of(Nfe::Webservices::Wsinfo::Production::Sp).
      to receive(:consult_emitter).and_return(:wsdl_sp)
      expect(subject.consult_emitter(:production, "SP")).to eql :wsdl_sp
    end
  end
end
