require "simplecov"
require "codeclimate-test-reporter"
CodeClimate::TestReporter.start
SimpleCov.start

require "bundler/setup"
require "webmock/rspec"

Bundler.require(:default, :development)
Dir[File.dirname(__FILE__) + "/support/*.rb"].each { |f| require f }
Dir[File.dirname(__FILE__) + "/factories/*.rb"].each { |f| require f }
Dir[File.dirname(__FILE__) + "/nfe/factories/**/*.rb"].each { |f| require f }

I18n.locale = "pt-BR";
WebMock.disable_net_connect!(allow: "codeclimate.com")

RSpec.configure do |config|
  config.expect_with :rspec do |c|
    c.syntax = :expect
  end

  config.order = :random
  config.include FactoryGirl::Syntax::Methods
end

require "httpclient"
require "vcr"

VCR.configure do |c|
  c.cassette_library_dir = "spec/nfe/fixtures/cassettes"
  c.hook_into :webmock
  c.default_cassette_options = { record: :new_episodes }
end
