require "spec_helper"

describe Xmldsig::EnvelopedSignature do
  let(:xml) { File.read("spec/xmldsig/fixtures/unsigned_nested_signature.xml") }
  let(:doc) { Xmldsig::SignedDocument.new(xml) }

  it "only removes the first signature element" do
    node_with_nested_signature = doc.signatures.last.references.first.referenced_node

    Xmldsig::EnvelopedSignature.new(node_with_nested_signature, nil).transform

    remaining_signatures = node_with_nested_signature.xpath(
      "descendant::ds:Signature", Xmldsig::NAMESPACES)
    signature = Xmldsig::Signature.new(remaining_signatures.first)

    expect(remaining_signatures.count).to eql 1
    expect(signature.references.first.reference_uri).to eql "#baz"
  end
end
