require "spec_helper"

describe Nfe::Models::Transport::Lacres do
  subject { build(:lacres) }

  it "has a valid factory" do
    expect(subject).to be_valid
  end

  it { is_expected.to validate_presence_of :nLacre }
  it { is_expected.to ensure_length_of(:nLacre).is_at_least(1).is_at_most(60) }

  context "when xml has all tags" do
    let(:xml) do
      xml  = "<nLacre>AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA</nLacre>"
    end

    describe "#to_xml" do
      it "returns a formatted xml" do
        expect(subject.to_xml).to eql xml
      end
    end

    describe "#parse!" do
      subject { Nfe::Models::Transport::Lacres.new }
      before { subject.parse!("<root>#{xml}</root>") }

      it "parses xml values to itself" do
        expect(subject.nLacre).to eql "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA"
      end

      it { is_expected.to be_valid }
    end
  end
end
